/*
	I2C.c
	׼80C51ƬģI2Cߵ
	Copyright (c) 2005Ƭչ޹˾
	All rights reserved.
	ѧϰοṩκοɿԷĵҵĿ
*/

#include "I2C.h"

//ʱںI2C_Delay()
unsigned char data I2C_Delay_t;

/*
궨壺I2C_Delay()
ܣʱģI2Cר
*/
#define I2C_Delay()\
{\
	I2C_Delay_t = (I2C_DELAY_VALUE);\
	while ( --I2C_Delay_t != 0 );\
}

/*
I2C_Init()
ܣI2C߳ʼʹߴڿ״̬
˵main()ĿʼͨӦҪִһα
*/
void I2C_Init()
{
	I2C_SCL = 1;
	I2C_Delay();
	I2C_SDA = 1;
	I2C_Delay();
}

/*
I2C_Start()
ܣI2Cߵʼ״̬
˵
	SCLڸߵƽڼ䣬SDA½ʱI2C
	SDASCLʲôƽ״̬ȷʼ״̬
	Ҳظʼ״̬
	ִкI2Cߴæ״̬
*/
void I2C_Start()
{
	I2C_SDA = 1;
	I2C_Delay();
	I2C_SCL = 1;
	I2C_Delay();
	I2C_SDA = 0;
	I2C_Delay();
	I2C_SCL = 0;
	I2C_Delay();
}

/*
I2C_Write()
ܣI2Cд1ֽڵ

	datҪдϵ
*/
void I2C_Write(char dat)
{
	unsigned char t = 8;
	do
	{
		I2C_SDA = (bit)(dat & 0x80);
		dat <<= 1;
		I2C_SCL = 1;
		I2C_Delay();
		I2C_SCL = 0;
		I2C_Delay();
	} while ( --t != 0 );
}

/*
I2C_Read()
ܣӴӻȡ1ֽڵ
أȡһֽ
*/
char I2C_Read()
{
	char dat;
	unsigned char t = 8;
	I2C_SDA = 1;	//ڶȡ֮ǰҪSDA
	do
	{
		I2C_SCL = 1;
		I2C_Delay();
		dat <<= 1;
		if ( I2C_SDA ) dat |= 0x01;
		I2C_SCL = 0;
		I2C_Delay();
	} while ( --t != 0 );
	return dat;
}

/*
I2C_GetAck()
ܣȡӻӦλ
أ
	0ӻӦ
	1ӻӦ
˵
	ӻյÿֽڵݺҪӦλ
	ӻյ1ֽڵݺһҪӦλ
*/
bit I2C_GetAck()
{
	bit ack;
	I2C_SDA = 1;
	I2C_Delay();
	I2C_SCL = 1;
	I2C_Delay();
	ack = I2C_SDA;
	I2C_SCL = 0;
	I2C_Delay();
	return ack;
}

/*
I2C_PutAck()
ܣӦλӦλ

	ack=0Ӧλ
	ack=1Ӧλ
˵
	ڽÿһֽڵݺ󣬶ӦӦλ
	ڽһֽڵݺӦӦλ
*/
void I2C_PutAck(bit ack)
{
	I2C_SDA = ack;
	I2C_Delay();
	I2C_SCL = 1;
	I2C_Delay();
	I2C_SCL = 0;
	I2C_Delay();
}

/*
I2C_Stop()
ܣI2Cߵֹͣ״̬
˵
	SCLڸߵƽڼ䣬SDAʱֹͣI2C
	SDASCLʲôƽ״̬ȷֹͣ״̬
	ִкI2Cߴڿ״̬
*/
void I2C_Stop()
{
	unsigned int t = I2C_STOP_WAIT_VALUE;
	I2C_SDA = 0;
	I2C_Delay();
	I2C_SCL = 1;
	I2C_Delay();
	I2C_SDA = 1;
	I2C_Delay();
	while ( --t != 0 );		//һβStart֮ǰҪһʱ
}

/*
I2C_Puts()
ܣI2CۺϷͺӻͶֽڵ

	SlaveAddrӻַ7λַдλ
	SubAddrӻӵַ
	SubModӵַģʽ0ӵַ1ֽӵַ2˫ֽӵַ
	*datҪ͵
	Sizeݵֽ
أ
	0ͳɹ
	1ڷ͹г쳣
˵
	ܹܺõӦгI2CǷӵַ
	ӻûӵַʱSubAddr⣬SubModӦΪ0
*/
bit I2C_Puts
(
	unsigned char SlaveAddr,
	unsigned int SubAddr,
	unsigned char SubMod,
	char *dat,
	unsigned int Size
)
{
//ʱ
	unsigned char i;
	char a[3];
//鳤
	if ( Size == 0 ) return 0;
//׼ӻַ
	a[0] = (SlaveAddr << 1);
//ӵַģʽ
	if ( SubMod > 2 ) SubMod = 2;
//ȷӵַ
	switch ( SubMod )
	{
	case 0:
		break;
	case 1:
		a[1] = (char)(SubAddr);
		break;
	case 2:
		a[1] = (char)(SubAddr >> 8);
		a[2] = (char)(SubAddr);
		break;
	default:
		break;
	}
//ʹӻַŷӵַӵַĻ
	SubMod++;
	I2C_Start();
	for ( i=0; i<SubMod; i++ )
	{
		I2C_Write(a[i]);
		if ( I2C_GetAck() )
		{
			I2C_Stop();
			return 1;
		}
	}
//
	do
	{
		I2C_Write(*dat++);
		if ( I2C_GetAck() ) break;
	} while ( --Size != 0 );
//ϣֹͣI2Cߣؽ
	I2C_Stop();
	if ( Size == 0 )
	{
		return 0;
	}
	else
	{
		return 1;
	}
}

/*
I2C_Gets()
ܣI2CۺϽպӴӻնֽڵ

	SlaveAddrӻַ7λַдλ
	SubAddrӻӵַ
	SubModӵַģʽ0ӵַ1ֽӵַ2˫ֽӵַ
	*datյ
	Sizeݵֽ
أ
	0ճɹ
	1ڽչг쳣
˵
	ܹܺõӦгI2CǷӵַ
	ӻûӵַʱSubAddr⣬SubModӦΪ0
*/
bit I2C_Gets
(
	unsigned char SlaveAddr,
	unsigned int SubAddr,
	unsigned char SubMod,
	char *dat,
	unsigned int Size
)
{
//ʱ
	unsigned char i;
	char a[3];
//鳤
	if ( Size == 0 ) return 0;
//׼ӻַ
	a[0] = (SlaveAddr << 1);
//ӵַģʽ
	if ( SubMod > 2 ) SubMod = 2;
//ӵַĴӻҪȷʹӻַӵַ
	if ( SubMod != 0 )
	{
	//ȷӵַ
		if ( SubMod == 1 )
		{
			a[1] = (char)(SubAddr);
		}
		else
		{
			a[1] = (char)(SubAddr >> 8);
			a[2] = (char)(SubAddr);
		}
	//ʹӻַŷӵַ
		SubMod++;
		I2C_Start();
		for ( i=0; i<SubMod; i++ )
		{
			I2C_Write(a[i]);
			if ( I2C_GetAck() )
			{
				I2C_Stop();
				return 1;
			}
		}
	}
//I2C_Start()ӵַĴӻظʼ״̬
//ӵַĴӻʼ״̬
	I2C_Start();
//ʹӻַ
	I2C_Write(a[0]+1);
	if ( I2C_GetAck() )
	{
		I2C_Stop();
		return 1;
	}
//
	for (;;)
	{
		*dat++ = I2C_Read();
		if ( --Size == 0 )
		{
			I2C_PutAck(1);
			break;
		}
		I2C_PutAck(0);
	}
//ϣֹͣI2Cߣؽ
	I2C_Stop();
	return 0;
}
