/*
	ZLG7290ʾ
*/

#include "I2C.h"
#include "ZLG7290.h"

//жϱ־FlagINT=1ʾм
volatile bit FlagINT = 0;

/*
INT0_SVC()
ܣZLG7290жϷ
˵жϴʽѡ񸺱ش˲صȴжźŻָΪߵƽ
*/
void INT0_SVC() interrupt 0
{
	FlagINT = 1;
}

/*
Delay()
ܣʱ10ms655.36s

	t>0ʱʱ(t*0.01)s
	t=0ʱʱ655.36s
˵
	11.0592MHz
*/
void Delay(unsigned int t)
{
	do
	{
		TH0 = 0xDC;
		TL0 = 0x00;
		TR0 = 1;
		while ( !TF0 );
		TF0 = 0;
		TR0 = 0;
	} while (--t);
}

/*
SystemInit()
ܣϵͳʼ
*/
void SystemInit()
{
	I2C_Init();
	TMOD = 0x01;
	Delay(30);		//ȴZLG7290λ
}

/*
ClearAll()
ܣʾ
*/
void ClearAll()
{
	unsigned char x;
	for ( x=0; x<8; x++ )
	{
		ZLG7290_Download(x,0,0,31);
	}
}

/*
Test_DispBuf()
ܣֱдԴ
*/
void Test_DispBuf()
{
	code char DispDat[16] =
	{//ĸAbCdEFgHiJkLoPqr
		0xEE,0x3E,0x9C,0x7A,0x9E,0x8E,0xF6,0x6E,
		0x20,0x70,0x0E,0x1C,0x3A,0xCE,0xE6,0x0A
	};
	unsigned char n;
	unsigned char x;
	unsigned char reg;
	unsigned char dat;
	for ( n=0; n<16; n++ )
	{
		for ( x=0; x<8; x++ )
		{
			reg = ZLG7290_DpRam + x;
			dat = DispDat[n];
			ZLG7290_WriteReg(reg,dat);
		}
		Delay(50);
	}
}

/*
Test_Download()
ܣݹ
*/
void Test_Download()
{
	unsigned char x;
	bit dp;
	bit flash;
	char dat;
//
	dp = 1;
	flash = 0;
	dat = 8;
	for ( x=0; x<8; x++ )
	{
		ZLG7290_Download(x,dp,flash,dat);
	}
	Delay(100);
//ʾ
	dp = 0;
	flash = 0;
	for ( dat=0; dat<32; dat++ )
	{
		for ( x=0; x<8; x++ )
		{
			ZLG7290_Download(x,dp,flash,dat);
		}
		Delay(50);
	}
}

/*
Test_ScanNum()
ܣԲͬɨλ
˵ɨλԽ٣ܾԽ
*/
void Test_ScanNum()
{
	unsigned char x;
	for ( x=0; x<8; x++ )
	{
		ZLG7290_Download(x,1,0,8);
	}
	Delay(100);
	for ( x=0; x<8; x++ )
	{
		ZLG7290_WriteReg(ZLG7290_ScanNum,x);
		Delay(100);
	}
}

/*
Test_Flash()
ܣ˸
*/
void Test_Flash()
{
	char dat = 0x01;
	unsigned char x;
//ʾ01234567
	for ( x=0; x<8; x++ )
	{
		ZLG7290_Download(x,0,0,x);
	}
//˸ƼĴ
	ZLG7290_WriteReg(ZLG7290_FlashOnOff,0x11);	
//˸ʾ
	for ( x=0; x<8; x++ )
	{
		ZLG7290_Flash(dat);
		dat <<= 1;
		Delay(300);
	}
//ܵ8λһ˸
	ZLG7290_Flash(0xFF);
	Delay(350);
//ֹͣ˸
	ZLG7290_Flash(0x00);
	Delay(50);
}

/*
Test_SegOnOff()
ܣԶѰַ
*/
void Test_SegOnOff()
{
	unsigned char seg;
	ClearAll();
	Delay(100);
	for ( seg=0; seg<64; seg++ )
	{
		ZLG7290_SegOnOff(seg,1);
		Delay(30);
	}
	Delay(100);
	for ( seg=0; seg<64; seg++ )
	{
		ZLG7290_SegOnOff(seg,0);
		Delay(30);
	}
	Delay(100);
}

/*
DispValue()
ܣʾ100ڵֵ

	xʾλãȡֵ06
	datҪʾݣȡֵ099
*/
void DispValue(char x, unsigned char dat)
{
	unsigned char d;
	d = dat / 10;
	ZLG7290_Download(x,0,0,d);
	d = dat - d * 10;
	ZLG7290_Download(x+1,0,0,d);
}

/*
DispHexValue()
ܣ16Ʒʽʾֵ

	xʾλãȡֵ06
	datҪʾݣȡֵ0255
*/
void DispHexValue(char x, unsigned char dat)
{
	unsigned char d;
	d = dat / 16;
	ZLG7290_Download(x,0,0,d);
	d = dat - d * 16;
	ZLG7290_Download(x+1,0,0,d);
}

/*
Test_Key()
ܣ԰
*/
void Test_Key()
{
	unsigned char KeyValue;
	unsigned char RepeatCnt;
	unsigned char FnKeyValue;
	ClearAll();
	EA = 0;
	IT0 = 1;	//شж
	EX0 = 1;	//ⲿж
	EA = 1;
	for (;;)
	{
		if ( FlagINT )		//м
		{
		//жϱ־
			FlagINT = 0;
		//ȡֵֵֵܼ
			ZLG7290_ReadReg(ZLG7290_Key,&KeyValue);
			ZLG7290_ReadReg(ZLG7290_RepeatCnt,&RepeatCnt);
			ZLG7290_ReadReg(ZLG7290_FunctionKey,&FnKeyValue);
		//ʾֵֵֵܼ
			DispValue(0,KeyValue);
			DispHexValue(3,RepeatCnt);
			DispHexValue(6,FnKeyValue);
		}
		PCON |= 0x01;	//ʹCPU״̬һжϿɻ
	}
}

void main()
{
	SystemInit();		//ϵͳʼ
	Test_DispBuf();		//ֱдԴ
	Test_Download();	//
	Test_ScanNum();	//Բͬɨλ
	Test_Flash();		//˸
	Test_SegOnOff();	//ԶѰַ
	Test_Key();		//Լ̹
	while (1);
}
